from a7 import *
import numpy as np


def test_edit_distance():
    for w1, w2, d in [("abcdef", "agciu", 4),
                      ("abcdef", "egciu", 5),
                      ("abcdef", "kgciu", 5)]:
        assert np.isclose(edit_distance(w1, w2, weights=[1, 1, 1, 1, 1]),
                          d)


def test_edit_distance_w():
    for w1, w2, d in [
        ("abcdef", "agciu", 5.5),
        ("abcdef", "egciu", 6.0),
        ("abcdef", "kgciu", 6.0),
    ]:
        assert np.isclose(
            edit_distance(w1, w2, weights=[0.5, 1.0, 2.0, 0.5, 2.0]), d)


def test_language_distance():
    for l1, l2, l3 in [
        ("deu", "nld", "eng"),
        ("deu", "dan", "ita"),
        ("deu", "eng", "cmn"),
    ]:
        assert language_distance(l1, l2) < language_distance(l1, l3)
